diff --git b/hung_patch_from_arnt/aox/server/selector.cpp a/instrumentation/aox/server/selector.cpp
index 7a910e4..1b68a2a 100644
--- b/hung_patch_from_arnt/aox/server/selector.cpp
+++ a/instrumentation/aox/server/selector.cpp
@@ -1721,7 +1721,6 @@ EString Selector::whereNoField()
 {
     if ( d->a == And ) {
         bool f = false;
-        int oldPlaceholder = root()->d->placeholder;
         EStringList conditions;
         List<Selector>::Iterator i( d->children );
         while ( i ) {
@@ -1734,7 +1733,7 @@ EString Selector::whereNoField()
         }
         if ( conditions.isEmpty() )
             return "true";
-        if ( f && oldPlaceholder == root()->d->placeholder )
+        if ( f )
             return "false";
         if ( conditions.count() == 1 )
             return conditions.join( "" );
@@ -1973,13 +1972,10 @@ EString Selector::debugString() const
         break;
     case Age:
         w = "age";
-        break;
     case DatabaseId:
         w = "database-id";
-        break;
     case ThreadId:
         w = "thread-id";
-        break;
     };
 
     r = w + " " + o + " ";
diff --git b/hung_patch_from_arnt/aox/server/server.cpp a/instrumentation/aox/server/server.cpp
index 4cd69ee..b853071 100644
--- b/hung_patch_from_arnt/aox/server/server.cpp
+++ a/instrumentation/aox/server/server.cpp
@@ -207,7 +207,7 @@ void Server::setup( Stage s )
             }
             d->stage = (Stage)(d->stage + 1);
         }
-    } catch ( const Exception& e ) {
+    } catch ( Exception e ) {
         // don't allocate memory or call anything here.
         const char * c = 0;
         switch (e) {
diff --git b/hung_patch_from_arnt/aox/server/session.cpp a/instrumentation/aox/server/session.cpp
index b5f1fab..4c93765 100644
--- b/hung_patch_from_arnt/aox/server/session.cpp
+++ a/instrumentation/aox/server/session.cpp
@@ -8,6 +8,7 @@
 #include "selector.h"
 #include "mailbox.h"
 #include "message.h"
+#include "cache.h"
 #include "event.h"
 #include "query.h"
 #include "scope.h"
@@ -36,9 +37,31 @@ public:
     int64 nextModSeq;
     Permissions * permissions;
     IntegerSet unannounced;
+
+    class CachedData
+        : public Garbage
+    {
+    public:
+        CachedData(): Garbage(), uidnext( 0 ), nextModSeq( 1 ) {}
+        uint uidnext;
+        int64 nextModSeq;
+        IntegerSet msns;
+    };
+
+    class SessionCache
+        : public Cache
+    {
+    public:
+        SessionCache(): Cache( 3 ) {}
+        Map<CachedData> data;
+        void clear() { data.clear(); }
+    };
 };
 
 
+static SessionData::SessionCache * cache = 0;
+
+
 /*! \\class Session session.h
     This class contains all data associated with the single use of a
     Mailbox, such as the number of messages visible, etc. Subclasses
@@ -46,7 +69,7 @@ public:
 */
 
 /*! Creates a new Session for the Mailbox \\a m. If \\a readOnly is
-    true, the session is read-only.
+    true, the session is read-only.  
 */
 
 Session::Session( Mailbox * m, bool readOnly )
@@ -65,6 +88,14 @@ Session::Session( Mailbox * m, bool readOnly )
         d->msns.add( other->d->unannounced );
         d->msns.remove( other->d->expunges );
     }
+    else if ( cache ) {
+        SessionData::CachedData * cd = cache->data.find( m->id() );
+        if ( cd ) {
+            d->uidnext = cd->uidnext;
+            d->nextModSeq = cd->nextModSeq;
+            d->msns.add( cd->msns );
+        }
+    }
     (void)new SessionInitialiser( m, 0, this );
 }
 
@@ -790,3 +821,131 @@ void Session::clearUnannounced()
 void Session::sendFlagUpdate()
 {
 }
+
+
+class SessionPreloaderData
+    : public Garbage
+{
+public:
+    SessionPreloaderData(): owner( 0 ), lock( 0 ), uids( 0 ), done( false ) {}
+
+    List<Mailbox> l;
+    EventHandler * owner;
+    Query * lock;
+    Query * uids;
+    bool done;
+};
+
+
+/*! \\class SessionPreloader session.h
+
+    Loads information about selected mailboxes into the session cache,
+    so that newly-created sessions have access to it straightaway.
+*/
+
+/*!  Constructs a SessionPreloader which will preload the session cache
+     with information about \\a mailboxes, and then notify \\a handler.
+
+     If the cache already contains all that information, then
+     execute() will set done() and not call \\a handler.
+*/
+
+SessionPreloader::SessionPreloader( List<Mailbox> * mailboxes,
+                                  EventHandler * handler )
+    : d( new SessionPreloaderData )
+{
+    List<Mailbox>::Iterator i( mailboxes );
+    while ( i ) {
+        d->l.append( i );
+        ++i;
+    }
+    d->owner = handler;
+}
+
+
+void SessionPreloader::execute()
+{
+    if ( !::cache )
+        ::cache = new SessionData::SessionCache;
+
+    if ( !d->uids ) {
+        IntegerSet e;
+        IntegerSet a;
+        IntegerSet s;
+        List<Mailbox>::Iterator i( d->l );
+        while ( i ) {
+            if ( i->uidnext() <= 1 )
+                e.add( i->id() );
+            else if ( ::cache->data.find( i->id() ) )
+                a.add( i->id() );
+            else
+                s.add( i->id() );
+            ++i;
+        }
+        if ( s.count() > 2 ) {
+            log( "Session preloader: " +
+                 fn( a.count() ) + " already cached, " +
+                 fn( e.count() ) + " mailboxes empty, " +
+                 fn( s.count() ) + " can be preloaded." );
+            Transaction * t = new Transaction( this );
+            d->lock
+                = new Query( "select id, uidnext, nextmodseq, first_recent "
+                             "from mailboxes where id=any($1) "
+                             "order by id for update", 0 );
+            d->lock->bind( 1, s );
+            t->enqueue( d->lock );
+            d->uids = new Query( "select mailbox, uid from mailbox_messages "
+                                 "where mailbox=any($1)", this );
+            d->uids->bind( 1, s );
+            t->enqueue( d->uids );
+            t->commit();
+        }
+        else {
+            // for just 0-2 mailboxes this query won't be a net gain
+            d->done = true;
+        }
+    }
+
+    if ( !d->uids || !d->uids->done() )
+        return;
+
+    while ( d->lock->hasResults() ) {
+        Row * r = d->lock->nextRow();
+
+        SessionData::CachedData * cd = ::cache->data.find( r->getInt( "id" ) );
+        if ( !cd ) {
+            cd = new SessionData::CachedData;
+            ::cache->data.insert( r->getInt( "id" ), cd );
+        }
+
+        cd->uidnext = r->getInt( "uidnext" );
+        cd->nextModSeq = r->getBigint( "nextmodseq" );
+
+        // if there are recent messages the next SI has to look, so
+        // force it. sigh. recent is such a mess.
+        if ( cd->uidnext > (uint)r->getInt( "first_recent" ) )
+            cd->nextModSeq--;
+    }
+
+    while ( d->uids->hasResults() ) {
+        Row * r = d->uids->nextRow();
+        SessionData::CachedData * cd =
+            ::cache->data.find( r->getInt( "mailbox" ) );
+        if ( cd )
+            cd->msns.add( r->getInt( "uid" ) );
+    }
+
+    d->done = true;
+    d->owner->notify();
+}
+
+
+/*! Returns true if the SessionPreloader has done all it's going to do,
+    and false if it hasn't.
+
+*/
+
+bool SessionPreloader::done()
+{
+    return d->done;
+}
diff --git b/hung_patch_from_arnt/aox/server/session.h a/instrumentation/aox/server/session.h
index d5577b4..90440ef 100644
--- b/hung_patch_from_arnt/aox/server/session.h
+++ a/instrumentation/aox/server/session.h
@@ -99,4 +99,18 @@ private:
 };
 
 
+class SessionPreloader
+    : public EventHandler
+{
+public:
+    SessionPreloader( List<Mailbox> *, EventHandler * );
+
+    void execute();
+    bool done();
+
+private:
+    class SessionPreloaderData * d;
+};
+
+
 #endif
diff --git b/hung_patch_from_arnt/aox/server/timer.cpp a/instrumentation/aox/server/timer.cpp
index 42007bb..f30a381 100644
--- b/hung_patch_from_arnt/aox/server/timer.cpp
+++ a/instrumentation/aox/server/timer.cpp
@@ -135,7 +135,7 @@ void Timer::notify()
     try {
         d->owner->execute();
     }
-    catch ( const Exception& e ) {
+    catch ( Exception e ) {
         d->owner = 0; // so we can't get close to a segfault again
         if ( e == Invariant ) {
             // Analogous to EventLoop::dispatch, we try to close the
@@ -161,7 +161,7 @@ void Timer::notify()
             }
         }
         else {
-            throw;
+            throw e;
         }
     }
 }
diff --git b/hung_patch_from_arnt/aox/server/tlsthread.cpp a/instrumentation/aox/server/tlsthread.cpp
index e25ed6b..cb9e73d 100644
--- b/hung_patch_from_arnt/aox/server/tlsthread.cpp
+++ a/instrumentation/aox/server/tlsthread.cpp
@@ -93,14 +93,14 @@ void TlsThread::setup()
     SSL_library_init();
 
     ctx = ::SSL_CTX_new( SSLv23_server_method() );
-    long options = SSL_OP_ALL
-        // also try to pick the same ciphers suites more often
-        | SSL_OP_CIPHER_SERVER_PREFERENCE
-        // and don't use SSLv2, even if the client wants to
-        | SSL_OP_NO_SSLv2
-        // and not v3 either
-        | SSL_OP_NO_SSLv3
-        ;
+    int options = SSL_OP_ALL
+                  // also try to pick the same ciphers suites more often
+                  | SSL_OP_CIPHER_SERVER_PREFERENCE
+                  // and don't use SSLv2, even if the client wants to
+                  | SSL_OP_NO_SSLv2
+                  // and not v3 either
+                  | SSL_OP_NO_SSLv3
+                  ;
     SSL_CTX_set_options( ctx, options );
 
     SSL_CTX_set_cipher_list( ctx, "kEDH:HIGH:!aNULL:!MD5" );
[
